import java.io.*;
import javax.swing.*;
import javax.swing.filechooser.FileNameExtensionFilter;
import java.util.*;

/**
 * Generates Shakespearean insults. 
 * References: http://www.pangloss.com/seidel/shake_rule.html
 * http://www.pangloss.com/seidel/Shaker/
 * http://www.renfaire.com/Language/insults.html
 * Generates three-word insults from Shakespearean vocabulary
 * 
 * @author Chuck Hommel, Abu Shahriar, Joel Ross
 * @author  YOUR NAME GOES HERE
 * 
 * @version Sp 2013
 */
public class Insulter
{

    //TODO: Declare necessary instance variables here


    /**
     * Creates a new Insulter object, which loads data and displays insults
     */
    public Insulter()
    {

        //TODO: initialize the instance variables here


        showGreeting(); //get started
        boolean dataLoaded = loadData(); //load the vocabulary lists
        if(dataLoaded) //make sure we got some data!
        {
            int response = JOptionPane.YES_OPTION; //initialize as "yes"
            while(response == JOptionPane.YES_OPTION) //while they want to continue
            {
                response = showInsult(); //Insult and get response
            }

            showGoodbye(); //say goodbye!
        }
    }

    /** 
     * load data from file
     */
    private void loadData()
    {
        File file = null; //the file we will open

        JFileChooser chooser = new JFileChooser(); //a file chooser
        chooser.setFileFilter(new FileNameExtensionFilter("Text files", "txt")); //make it so our chooser can only pick text files
        int status = chooser.showOpenDialog(chooser); //show the open dialog
        if(status == JFileChooser.APPROVE_OPTION) //if a file is picked
        {
            file = chooser.getSelectedFile(); //get the file from the chooser
            try
            {

                //TODO: create a Scanner for the file object
                //TODO: parse the file line by line and add words to lists
                //TODO: remember to close the Scanner when you're done!

                return true; //return that we've successfully loaded data
            }
            catch (IOException e)//catch if any problem occurs while reading the file
            {
                System.out.println ("Error reading file: " + e.getMessage());
                e.printStackTrace(); //show the stack trace so we can track down the error
            }
        }
        return false; //if we got down here, then we must have hit a problem, so failed to load the data
    }

    /**
     * Constructs a random insult using the lists of words
     * @return A string that is the insult
     */
    private String buildInsult()
    {

       //TODO: create and return an insult message

    }

    /** 
     * Shows the Shakespearean insult, and asks the user if they want to be insulted again
     * @return code to indicate whether or not to continue: matches JOptionPane.YES_OPTION and JOptionPane.NO_OPTION
     */
    private int showInsult()
    {

        //TODO: use a helper method to get an insult, display the insult using a dialog box, 
        //      get response regarding whether to continue or not, and return the response

    }

    /** 
     * Shows a greeting
     */
    private void showGreeting()
    {
        //Displaying welcome message using a message dialog box
        //You can look up the details of this parameters in the JOptionPane documentation
        //http://docs.oracle.com/javase/7/docs/api/javax/swing/JOptionPane.html
        JOptionPane.showMessageDialog(null,  "Welcome to the Shakespearean Insult Generator. Shall we proceed?", "Welcome", JOptionPane.INFORMATION_MESSAGE);
    }

    /** 
     * Shows a final insult as a goodbye message.
     */
    private void showGoodbye()
    {

        //TODO: display the last parting insult using a message dialog box and say good bye 

    }
}
